#include <vector>
#include <cstdio>
#include <cstdlib>
#include "swaps.h"

using namespace std;

namespace {
  constexpr int SCHEDULE = 946149565,
                   VISIT = 547293220,
                  ANSWER = 345685428;
  
  int N;
  vector<bool> queryIndices;
}

int safely_read_int() {
  int i;
  if (scanf("%d", &i)) {}
  return i;
}

void schedule(int i, int j) {
	if (i < 1 || i > N || !(queryIndices[i] = !queryIndices[i]) || j < 1 || j > N || !(queryIndices[j] = !queryIndices[j])) {
    printf("%d -1\n", SCHEDULE);
    fflush(stdout);
    exit(0);
  }
  printf("%d %d %d\n", SCHEDULE, i, j);
}

vector<int> visit() {
  queryIndices.assign(N + 1, false);

  printf("%d\n", VISIT);
  fflush(stdout);

  int k = safely_read_int();
  if (k == -1)
    exit(0);

  vector<int> res(k);
  for (int i = 0; i < k; i++) {
    res[i] = safely_read_int();
    if (res[i] == -1)
      exit(0);
  }
  return res;
}

void answer(vector<int> r) {
  if ((int) r.size() != N)
    printf("%d -1\n", ANSWER);
  else {
    printf("%d", ANSWER);
    for (int x : r)
      printf(" %d", x);
    printf("\n");
  }
  fflush(stdout);

  exit(0);
}

int main() {
  N = safely_read_int();
  queryIndices.assign(N + 1, false);
  int V = safely_read_int();
  solve(N, V);
}
